From a6e02bdca60297bd5d24394a0b04629e6f6520ce Mon Sep 17 00:00:00 2001
From: Nicolas ROCHE <nroche@entrouvert.com>
Date: Thu, 8 Dec 2022 17:06:58 +0100
Subject: [PATCH 4/7] toulouse-maelis: move referentials into db (#70982)

---
 .../migrations/0002_referential.py            |  43 +
 passerelle/contrib/toulouse_maelis/models.py  | 182 +++--
 .../R_read_category_list_2_items.xml          |  15 +
 tests/test_toulouse_maelis.py                 | 772 +++++++-----------
 4 files changed, 468 insertions(+), 544 deletions(-)
 create mode 100644 passerelle/contrib/toulouse_maelis/migrations/0002_referential.py
 create mode 100644 tests/data/toulouse_maelis/R_read_category_list_2_items.xml

diff --git a/passerelle/contrib/toulouse_maelis/models.py b/passerelle/contrib/toulouse_maelis/models.py
index 3d8cdfcd..3ad5038e 100644
--- a/passerelle/contrib/toulouse_maelis/models.py
+++ b/passerelle/contrib/toulouse_maelis/models.py
@@ -8,32 +8,35 @@
 # This program is distributed in the hope that it will be useful,
 # but WITHOUT ANY WARRANTY; without even the implied warranty of
 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 # GNU Affero General Public License for more details.
 #
 # You should have received a copy of the GNU Affero General Public License
 # along with this program.  If not, see <http://www.gnu.org/licenses/>.
 
-from operator import itemgetter
 from urllib.parse import urljoin
 
 import zeep
-from django.core.cache import cache
+from django.contrib.postgres.fields import JSONField
 from django.db import models
 from zeep.helpers import serialize_object
 from zeep.wsse.username import UsernameToken
 
 from passerelle.base.models import BaseResource, HTTPResource
 from passerelle.utils.api import endpoint
 from passerelle.utils.jsonresponse import APIError
 
 from . import schemas
 
 
+class UpdateError(Exception):
+    pass
+
+
 class ToulouseMaelis(BaseResource, HTTPResource):
     # noqa pylint: disable=too-many-public-methods
 
     base_wsdl_url = models.CharField(
         max_length=128,
         blank=False,
         verbose_name='URL de base des WSDL',
         default='https://demo-toulouse.sigec.fr/maelisws-toulouse/services/',
@@ -66,77 +69,112 @@ class ToulouseMaelis(BaseResource, HTTPResource):
         except zeep.exceptions.Fault as e:
             raise APIError(e.message, err_code='%s-%s-%s' % (wsdl_short_name, service, e.code))
 
     def check_status(self):
         assert self.call('Family', 'isWSRunning')
         assert self.call('Activity', 'isWSRunning')
         assert self.call('Invoice', 'isWSRunning')
 
-    def get_referential(self, referential_name):
+    def update_referential(self, referential_name):
+        id_key, text_key = 'id', 'text'
 
         # local referentials
         if referential_name == 'Complement':
             response = [
                 {'id': 'B', 'text': 'bis'},
                 {'id': 'Q', 'text': 'quater'},
                 {'id': 'T', 'text': 'ter'},
             ]
-            return {'list': response, 'dict': {x['id']: x['text'] for x in response}}
         elif referential_name == 'Sex':
             response = [
                 {'id': 'F', 'text': 'Féminin'},
                 {'id': 'M', 'text': 'Masculin'},
             ]
-            return {'list': response, 'dict': {x['id']: x['text'] for x in response}}
-
-        # remote referentials
-        cache_key = 'maelis-%s-%s' % (self.pk, referential_name)
-        data = cache.get(cache_key)
-        if data is None:
-            response = self.call('Family', 'read' + referential_name + 'List')
-            data_list = []
+        else:
+            # remote referentials
+            try:
+                response = self.call('Family', 'read' + referential_name + 'List')
+                response = serialize_object(response)
+            except Exception as e:
+                raise UpdateError('Service indisponible : %s' % str(e))
             if referential_name == 'Organ':
-                data_list = [{'id': x.id, 'text': x.code} for x in response]
+                id_key, text_key = 'id', 'code'
             elif referential_name == 'Street':
-                data_list = [{'id': x.idStreet, 'text': x.libelleStreet} for x in response]
+                id_key, text_key = 'idStreet', 'libelleStreet'
             elif 'Indicator' in referential_name:
-                data_list = []
-                for item in serialize_object(response):
-                    item['id'] = item['code']
-                    item['text'] = item['label']
-                    data_list.append(item)
+                id_key, text_key = 'code', 'label'
             else:
-                data_list = [{'id': x.code, 'text': x.libelle} for x in response]
-
-            # sort list on text
-            data_list.sort(key=itemgetter('text', 'id'))
-
-            # remove redundant codes from list
-            uniq_text = set()
-            uniq_data = []
-            for item in data_list:
-                item['text'] = item['text'].strip()
-                if item['text'] not in uniq_text:
-                    uniq_data.append(item)
-                    uniq_text.add(item['text'])
-
-            data = {
-                'list': uniq_data,
-                'dict': {x['id']: x['text'] for x in data_list},
-            }
-            # put in cache for two hours
-            cache.set(cache_key, data, 3600 * 2)
-        return data
+                id_key, text_key = 'code', 'libelle'
+
+        try:
+            latest_update = (
+                self.referential.filter(referential_name=referential_name).latest('updated').updated
+            )
+        except Referential.DoesNotExist:
+            latest_update = None
+
+        for item in response:
+            text = item[text_key].strip()
+            self.referential.update_or_create(
+                resource_id=self.id,
+                referential_name=referential_name,
+                item_id=item[id_key],
+                defaults={
+                    'item_text': text,
+                    'item_data': dict({'id': item[id_key], 'text': text}, **item),
+                },
+            )
+
+        # clean item removed from referential
+        if latest_update is not None:
+            self.referential.filter(referential_name=referential_name, updated=latest_update).delete()
+
+    def update_referentials(self):
+        for name in (
+            'Category',
+            'ChildIndicator',
+            'Civility',
+            'Complement',
+            'Country',
+            'CSP',
+            'DietCode',
+            'Organ',
+            'PAI',
+            'Quality',
+            'Quotient',
+            'RLIndicator',
+            'Sex',
+            'Situation',
+            'Street',
+            'Vaccin',
+        ):
+            self.logger.info('Mise à jour du réferentiels %s' % name)
+            self.update_referential(name)
+
+    def daily(self):
+        try:
+            self.update_referentials()
+        except UpdateError as e:
+            self.logger.warning('Erreur sur la mise à jour: %s' % e)
+        else:
+            self.logger.info('Réferentiels mis à jour.')
+
+    def get_referential(self, referential_name):
+        return [
+            x.item_data
+            for x in self.referential.distinct('referential_name', 'item_text').filter(
+                referential_name=referential_name
+            )
+        ]
 
     def get_referential_value(self, referential_name, key):
         try:
-            return self.get_referential(referential_name)['dict'][key]
-        except KeyError:
-            # Maelis DB not properly configurated
+            return self.referential.get(referential_name=referential_name, item_id=key).item_text
+        except Referential.DoesNotExist:
             self.logger.warning("No '%s' key into Maelis '%s' referential", key, referential_name)
             return key
 
     def get_link(self, NameID):
         try:
             return self.link_set.get(name_id=NameID)
         except Link.DoesNotExist:
             raise APIError('User not linked to family', err_code='not-linked')
@@ -252,17 +290,19 @@ class ToulouseMaelis(BaseResource, HTTPResource):
         self.add_text_value_to_family(data)
         return data
 
     def assert_key_in_referential(self, referential_name, key_value, keys_text, required=True):
         if not key_value:
             if required:
                 raise APIError("%s is required and could not be None" % keys_text, err_code='field-required')
             return
-        if key_value not in self.get_referential(referential_name)['dict']:
+        try:
+            self.referential.get(referential_name=referential_name, item_id=key_value)
+        except Referential.DoesNotExist:
             ref_text = "required " if required else ""
             ref_text = ref_text + "referential"
             raise APIError(
                 "%s key value '%s' do not belong to '%s' %s"
                 % (keys_text, key_value, referential_name, ref_text),
                 err_code='wrong-key',
             )
 
@@ -368,152 +408,152 @@ class ToulouseMaelis(BaseResource, HTTPResource):
 
     @endpoint(
         display_category='Famille',
         description='Liste des catégories',
         name='read-category-list',
         perm='can_access',
     )
     def read_category_list(self, request):
-        return {'data': self.get_referential('Category')['list']}
+        return {'data': self.get_referential('Category')}
 
     @endpoint(
         display_category='Famille',
         description='Liste des indicateurs sur le enfants',
         name='read-child-indicator-list',
         perm='can_access',
     )
     def read_child_indicator_list(self, request):
-        return {'data': self.get_referential('ChildIndicator')['list']}
+        return {'data': self.get_referential('ChildIndicator')}
 
     @endpoint(
         display_category='Famille',
         description='Liste des civilités',
         name='read-civility-list',
         perm='can_access',
     )
     def read_civility_list(self, request):
-        return {'data': self.get_referential('Civility')['list']}
+        return {'data': self.get_referential('Civility')}
 
     @endpoint(
         display_category='Famille',
         description='Liste des compléments du numéro de voie',
         name='read-complement-list',
         perm='can_access',
     )
     def read_complement_list(self, request):
-        return {'data': self.get_referential('Complement')['list']}
+        return {'data': self.get_referential('Complement')}
 
     @endpoint(
         display_category='Famille',
         description='Liste des pays',
         name='read-country-list',
         perm='can_access',
     )
     def read_country_list(self, request):
-        return {'data': self.get_referential('Country')['list']}
+        return {'data': self.get_referential('Country')}
 
     @endpoint(
         display_category='Famille',
         description='liste des catégories socio-professionnelles',
         name='read-csp-list',
         perm='can_access',
     )
     def read_csp_list(self, request):
-        return {'data': self.get_referential('CSP')['list']}
+        return {'data': self.get_referential('CSP')}
 
     @endpoint(
         display_category='Famille',
         description='Liste des régimes alimentaires',
         name='read-dietcode-list',
         perm='can_access',
     )
     def read_dietcode_list(self, request):
-        return {'data': self.get_referential('DietCode')['list']}
+        return {'data': self.get_referential('DietCode')}
 
     @endpoint(
         display_category='Famille',
         description='Liste des organismes (CAF)',
         name='read-organ-list',
         perm='can_access',
     )
     def read_organ_list(self, request):
-        return {'data': self.get_referential('Organ')['list']}
+        return {'data': self.get_referential('Organ')}
 
     @endpoint(
         display_category='Famille',
         description="Liste des projet d'accueil individualisés",
         name='read-pai-list',
         perm='can_access',
     )
     def read_pai_list(self, request):
-        return {'data': self.get_referential('PAI')['list']}
+        return {'data': self.get_referential('PAI')}
 
     @endpoint(
         display_category='Famille',
         description='liste des qualités du référenciel',
         name='read-quality-list',
         perm='can_access',
     )
     def read_quality_list(self, request):
-        return {'data': self.get_referential('Quality')['list']}
+        return {'data': self.get_referential('Quality')}
 
     @endpoint(
         display_category='Famille',
         description='Liste des quotients',
         name='read-quotient-list',
         perm='can_access',
     )
     def read_quotient_list(self, request):
-        return {'data': self.get_referential('Quotient')['list']}
+        return {'data': self.get_referential('Quotient')}
 
     @endpoint(
         display_category='Famille',
         description='Liste des indicateurs sur les responsables légaux',
         name='read-rl-indicator-list',
         perm='can_access',
     )
     def read_rl_indicator_list(self, request):
-        return {'data': self.get_referential('RLIndicator')['list']}
+        return {'data': self.get_referential('RLIndicator')}
 
     @endpoint(
         display_category='Famille',
         description='Liste des sexes',
         name='read-sex-list',
         perm='can_access',
     )
     def read_sex_list(self, request):
-        return {'data': self.get_referential('Sex')['list']}
+        return {'data': self.get_referential('Sex')}
 
     @endpoint(
         display_category='Famille',
         description='liste des situations',
         name='read-situation-list',
         perm='can_access',
     )
     def read_situation_list(self, request):
-        return {'data': self.get_referential('Situation')['list']}
+        return {'data': self.get_referential('Situation')}
 
     @endpoint(
         display_category='Famille',
         description='liste des voies',
         name='read-street-list',
         perm='can_access',
     )
     def read_street_list(self, request):
-        return {'data': self.get_referential('Street')['list']}
+        return {'data': self.get_referential('Street')}
 
     @endpoint(
         display_category='Famille',
         description='Liste des vaccins',
         name='read-vaccin-list',
         perm='can_access',
     )
     def read_vaccin_list(self, request):
-        return {'data': self.get_referential('Vaccin')['list']}
+        return {'data': self.get_referential('Vaccin')}
 
     @endpoint(
         display_category='Famille',
         description='Lier un compte usager à une famille',
         perm='can_access',
         parameters={'NameID': {'description': 'Publik NameID'}},
         post={'request_body': {'schema': {'application/json': schemas.LINK_SCHEMA}}},
     )
@@ -1165,8 +1205,30 @@ class Link(models.Model):
     resource = models.ForeignKey(ToulouseMaelis, on_delete=models.CASCADE)
     name_id = models.CharField(blank=False, max_length=256)
     family_id = models.CharField(blank=False, max_length=128)
     created = models.DateTimeField(auto_now_add=True)
     updated = models.DateTimeField(auto_now=True)
 
     class Meta:
         unique_together = ('resource', 'name_id')
+
+
+class Referential(models.Model):
+    resource = models.ForeignKey(
+        verbose_name='Resource',
+        to=ToulouseMaelis,
+        on_delete=models.CASCADE,
+        related_name='referential',
+    )
+    referential_name = models.CharField('Name', max_length=64)
+    item_id = models.CharField('Key', max_length=64)
+    item_text = models.CharField('Text', max_length=128)
+    item_data = JSONField('Data')
+    created = models.DateTimeField('Created', auto_now_add=True)
+    updated = models.DateTimeField('Updated', auto_now=True)
+
+    def __repr__(self):
+        return '<Referential "%s/%s">' % (self.referential_name, self.item_id)
+
+    class Meta:
+        ordering = ('referential_name', 'item_text', 'item_id')
+        unique_together = [['referential_name', 'item_id']]
